



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>angular controller之间通信方式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">angular controller之间通信方式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 03:47:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　对于日常开发中，难免会有controller之间通信需求。对于controller之间通信有两种方式可以做到。</p>
<p>用 Angular 进行开发，基本上都会遇到 Controller 之间通信的问题，本文对此进行一个总结。</p>
<p>在 Angular 中，Controller 之间通信的方式主要有三种：</p>
<p>1）作用域继承。利用子 Controller 控制父 Controller 上的数据。（父 Controller 中的数据要为引用类型，不能是基本类型，原因参见&nbsp;<a href="http://huangtengfei.com/2015/09/scope-in-angularjs/" rel="external nofollow noreferrer">AngularJS中的作用域</a>&nbsp;一文）</p>
<p>2）注入服务。把需要共享的数据注册为一个&nbsp;<code>service</code>，在需要的 Controller 中注入。</p>
<p>3）基于事件。利用 Angular 的事件机制，使用&nbsp;<code>$on</code>、<code>$emit</code>&nbsp;和&nbsp;<code>$boardcast</code></p>
<p>其中，作用域继承仅限于上下级之间的通信，注入服务和基于事件的机制可以实现任意级别的 Controller 通信。</p>
<p>在&nbsp;<a href="http://huangtengfei.github.io/angular-demo/#/communication-between-controllers" rel="external nofollow noreferrer">这里</a>&nbsp;可以查看下面栗子的演示。</p>
<h2>作用域继承</h2>
<p>原理在&nbsp;<a href="http://huangtengfei.com/2015/09/scope-in-angularjs/" rel="external nofollow noreferrer">作用域</a>&nbsp;一文中有讲解，这里直接上栗子。</p>
<p>页面：</p>
<div>
<div>
<pre class="prettyprint linenums">&lt;div ng-controller="parentCtrl"&gt;<br />
  &lt;p&gt;data in parent controller : {{data.name}}&lt;/p&gt;<br />
  &lt;div ng-controller="childCtrl"&gt;<br />
    &lt;input type="text" ng-model="data.name"&gt;<br />
  &lt;/div&gt;<br />
&lt;/div&gt;</pre>
</div>
</div>
<p>控制器：</p>
<div>
<div>
<pre class="prettyprint linenums">angular.module('demo', [])

.controller('parentCtrl', ['$scope', function($scope){<br />
    $scope.data = {<br />
        name: 'htf'<br />
    }<br />
}])

.controller('childCtrl', ['$scope', function($scope){

}])</pre>
</div>
</div>
<p>以上是父 Controller 中的数据是引用类型的情况。如果父 Controller 中的数据是基本类型，可通过<code>$scope.$parent.data</code>&nbsp;访问。</p>
<p>很显然，这种方式仅适用于父子级间 Controller 的通信。</p>
<h2>注入服务</h2>
<p>在 Angular 中，服务是一个单例，所以在服务中生成一个对象，该对象就可以利用依赖注入的方式在所有的控制器中共享。</p>
<p>看个栗子，先定义一个&nbsp;<code>service</code>&nbsp;:</p>
<div>
<div>
<pre class="prettyprint linenums">angular.module('demo')<br />
    .factory('Data', function(){<br />
        return {<br />
            name: 'htf'<br />
        };<br />
    })</pre>
</div>
</div>
<p>页面：</p>
<div>
<div>
<pre class="prettyprint linenums">&lt;div ng-controller="childCtrl1"&gt;<br />
  &lt;h3&gt;data in child controller 1 : {{data.name}}&lt;/h3&gt;<br />
  &lt;input class="form-control" type="text" ng-model="data.name"&gt;<br />
&lt;/div&gt;<br />
&lt;div ng-controller="childCtrl2"&gt;<br />
  &lt;h3&gt;data in child controller 2 : {{data.name}}&lt;/h3&gt;<br />
  &lt;input class="form-control" type="text" ng-model="data.name"&gt;<br />
&lt;/div&gt;</pre>
</div>
</div>
<p>控制器：</p>
<div>
<div>
<pre class="prettyprint linenums">.controller('childCtrl1', ['$scope', 'Data', function($scope, Data){<br />
    $scope.data = Data;<br />
}])

.controller('childCtrl2', ['$scope', 'Data', function($scope, Data){<br />
    $scope.data = Data;<br />
}])</pre>
</div>
</div>
<p>这种方式适用于任何需要通信的 Controller 之间。</p>
<h2>基于事件</h2>
<p>Angular 为&nbsp;<code>$scope</code>&nbsp;提供了冒泡和隧道机制，<code>$broadcast</code>&nbsp;会把事件广播给所有子 Controller，而&nbsp;<code>$emit</code>则会将事件冒泡传递给父 Controller，<code>$on</code>&nbsp;则是 Angular 的事件监听函数，利用这三者，可以实现上下级和同级（需要构造一个共同的父级 Controller）之间的通信。</p>
<h3>上下级之间</h3>
<p>这种情况下比较简单。</p>
<p>如果是子 Controller 往父 Controller 上发送事件（从作用域往上发送事件），使用&nbsp;<code>scope.$emit</code></p>
<div>
<pre class="prettyprint linenums">$scope.$emit("someEvent", {});</pre>
</div>
<p>如果是父 Controller 往子 Controller 上发送事件（从作用域往下发送事件），使用&nbsp;<code>scope.$broadcast</code></p>
<div>
<pre class="prettyprint linenums">$scope.$broadcast("someEvent", {});</pre>
</div>
<p>无论是&nbsp;<code>$emit</code>&nbsp;还是&nbsp;<code>$broadcast</code>&nbsp;发送的事件，都用&nbsp;<code>$scope.$on</code>&nbsp;接收：</p>
<div>
<div>
<pre class="prettyprint linenums">$scope.$on("someEvent", function(event, data) {<br />
    // 这里取到发送过来的数据 data<br />
});</pre>
</div>
</div>
<h3>同级之间</h3>
<p>同级之间利用事件通信有两种方法。一种是利用上下级之间事件传播的变形，另一种是借助&nbsp;<code>$rootScope</code>&nbsp;。</p>
<h4>借助父 controller</h4>
<p>先看第一种，在子 Controller 中向父 Controller 触发一个事件，然后在父 Controller 中监听事件，再广播给子 Controller ，这样通过事件携带的参数，实现了数据经过父 Controller，在同级 Controller 之间传播。</p>
<p>但是要注意，通过父 Controller 作为中介进行传递的话，子 Controller 触发的事件名和父 Controller 广播用的事件名不能一样，否则会进入死循环。</p>
<p>看代码：</p>
<div>
<div>
<pre class="prettyprint linenums">&lt;div ng-controller="outerCtrl"&gt;<br />
  &lt;h3&gt;data in outer controller: {{name}}&lt;/h3&gt;<br />
  &lt;div ng-controller="innerCtrl1"&gt;<br />
    &lt;input class="form-control" type="text" ng-model="name" ng-change="change()"&gt;<br />
  &lt;/div&gt;<br />
  &lt;div ng-controller="innerCtrl2"&gt;<br />
    &lt;input class="form-control" type="text" ng-model="name" ng-change="change()"&gt;<br />
  &lt;/div&gt;<br />
&lt;/div&gt;</pre>
</div>
</div>
<p>关键部分在控制器：</p>
<div>
<div>
<pre class="prettyprint linenums">.controller('outerCtrl', ['$scope', function($scope){<br />
    $scope.name = 'htf';<br />
    $scope.$on('dataChanged', function(event, data){<br />
        $scope.name = data;<br />
        // 2. 父 Ctrl 监听到 dataChanged 时间后，触发 changeData 事件<br />
        $scope.$broadcast('changeData', data);<br />
    })<br />
}])

.controller('innerCtrl1', ['$scope', function($scope){<br />
    $scope.change = function(){<br />
        // 1. 子 Ctrl1 中数据改变之后触发 dataChanged 事件<br />
        $scope.$emit('dataChanged', $scope.name);<br />
    }<br />
    $scope.$on('changeData', function(event, data){<br />
        $scope.name = data;<br />
    })<br />
}])

.controller('innerCtrl2', ['$scope', function($scope){<br />
    $scope.change = function(){<br />
        $scope.$emit('dataChanged', $scope.name);<br />
    }<br />
    // 3. 监听到 changeData 事件后，改变子 Ctrl2 中 数据<br />
    $scope.$on('changeData', function(event, data){<br />
        $scope.name = data;<br />
    })<br />
}])</pre>
</div>
</div>
<h4>借助 $rootScope</h4>
<p>每个 Angular 应用默认有一个根作用域&nbsp;<code>$rootScope</code>， 根作用域位于最顶层，从它往下挂着各级作用域。</p>
<p>所以，如果子控制器直接使用&nbsp;<code>$rootScope</code>&nbsp;广播和接收事件，那么就可实现同级之间的通信。</p>
<p>看栗子：</p>
<div>
<div>
<pre class="prettyprint linenums">&lt;div ng-controller="innerCtrlA"&gt;<br />
    &lt;input class="form-control" type="text" ng-model="name" ng-change="change()"&gt;<br />
&lt;/div&gt;<br />
&lt;div ng-controller="innerCtrlB"&gt;<br />
    &lt;input class="form-control" type="text" ng-model="name" ng-change="change()"&gt;<br />
&lt;/div&gt;</pre>
</div>
</div>
<p>控制器：</p>
<div>
<div>
<pre class="prettyprint linenums">.controller('innerCtrlA', ['$scope', '$rootScope', function($scope, $rootScope){<br />
    $scope.change = function(){<br />
        // 广播事件<br />
        $rootScope.$broadcast('nameChanged', $scope.name);<br />
    }<br />
    $rootScope.$on('nameChanged', function(event, data){<br />
        $scope.name = data;<br />
    })<br />
}])

.controller('innerCtrlB', ['$scope', '$rootScope', function($scope, $rootScope){<br />
    $scope.change = function(){<br />
        $rootScope.$broadcast('nameChanged', $scope.name);<br />
    }<br />
    // 监听事件<br />
    $rootScope.$on('nameChanged', function(event, data){<br />
        $scope.name = data;<br />
    })<br />
}])</pre>
</div>
</div>
<h2>参考</h2>
<ol><li><a href="https://github.com/xufei/blog/issues/18" rel="external nofollow noreferrer">作用域与事件</a></li>
<li><a href="http://www.cnblogs.com/whitewolf/archive/2013/04/16/3024843.html" rel="external nofollow noreferrer">Angularjs Controller 间通信机制</a></li>
<li><a href="http://www.tysoncadenhead.com/blog/communicating-between-controllers-in-angular#.VgSq7xHvMdU" rel="external nofollow noreferrer">Communicating Between Controllers In Angular</a></li>
<li><a href="http://segmentfault.com/a/1190000000639592" rel="external nofollow noreferrer">AngularJS控制器controller如何通信？</a></li>
<li><a href="http://www.angularjs.cn/A07b" rel="external nofollow noreferrer">controller 间共享数据</a></li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvv7eyq.html">【C&num;】菜单功能，将剪贴板JSON内容或者xml内容直接粘贴为类</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqddem7q.html">C&num;中文件多选 批量下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/495v01vq.html">如何理解clear的css属性&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kyr0r9.html">zoeDylan&period;ImgChange 图片切换插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdee57z9.html">OC正则表达式的简单使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oydr39.html">Java学习第四篇&colon;数组，排序，查找</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn16dm28.html">jQuery 简单归纳总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde6vxx9.html">C标准中一些预定义的宏</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kz5oz9.html">Eequal sum sets</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxknede8.html">Fedora 问题总结第二季</a>
		</li>
						<li><a href="https://www.batexi.com/a/96py4jy8.html">企业账号打包如何通过HTML页面打开</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kwkp59.html">elasticsearch单例模式连接</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gerw6z8.html">eclipse自定义代码模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj2m3lq.html">form表单样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj0wr69.html">flowable设计器插件安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ye52z8.html">threejs学习笔记（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv21rnz9.html">Spring再接触 整合Hibernate</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ozrwx8.html">&lbrack;JavaScript&rsqb; 弹出编辑框</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd617v9.html">mongo官方企业版安装及数据库授权使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyx76x9.html">原生NodeJs制作一个简易聊天室</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pjl01y9.html">linux下查看文件及目录个数</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdvjme8.html">SQL Server 存储过程之基础知识（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdvjxd8.html">Android中获取apk基本信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv6vozq.html">Python学习笔记2（控制语句）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn3n3pq.html">Python codes</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn17nnk8.html">关于Mysql不能被远程连接的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xep5z9.html">网关协议学习&colon;CGI、FastCGI、WSGI、uWSGI</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m677xq.html">欧拉（BC）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn3lmpq.html">centos6&period;4x64安装vncserver</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdeyy48.html">Eclipse 乱码解决方案（UTF8 -- GBK）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
